<template>
  <div class="section-detail">
    <LoadingSpinner v-if="loading" />
    <div v-if="loaded">
      <p>{{ section.description }}</p>
      <div v-if="canCreateTopics" class="mb-3">
        <router-link class="btn btn-primary" :to="createTopicRoute">
          <i class="bi bi-folder2-open"></i>
          Create New Topic
        </router-link>
      </div>
    </div>
  </div>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useStore } from 'vuex'
import { LoadingSpinner, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import SectionsApi from '../api/sections-api.js'

export default {
  name: 'SectionDetail',
  emits: ['loaded'],
  components: {
    LoadingSpinner,
  },
  props: {
    codeName: String,
  },
  setup(props, context) {
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const sectionsApi = new SectionsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const section = ref(undefined)

    const canCreateTopics = computed(() => {
      return store.state.identity.session.roles.includes('Member')
    })

    const createTopicRoute = computed(() => {
      return { name: 'forum-topic-create', params: { codeName: props.codeName } }
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      section.value = null

      try {
        const response = await sectionsApi.readAsync(props.codeName, { expand: 'all' })
        section.value = response.data
        loaded.value = true
        context.emit('loaded', section.value)
      } catch (ex) {
        notify.error('There was a problem getting the section.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    return {
      loading,
      loaded,
      section,
      canCreateTopics,
      createTopicRoute,
    }
  },
}
</script>
